#!/usr/bin/python
# -*- coding: utf-8 -*-

import socket
import time
import random

from pygame import mixer

class Instanssi(object):

	def __init__(self, nick, ip, port):
		self.ip = ip
		self.port = port
		self.nick = nick

		self.socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		self.reset()

	def reset(self):
		self.packet = [ 1 ] # Speksin versio aina yksi

		self.packet.append(0) # Aloita tagi osa
		for char in self.nick:
			self.packet.append(ord(char))
		self.packet.append(0) # Lopeta tagi osa


	def set(self, i, r, g, b):
		self.packet += [
			1, # Tehosteen tyyppi on yksi eli valo
			i, # Valon indeksi
			0, # Laajennustavu. Aina nolla. Älä välitä tästä
			r, # Punaisuus
			g, # Vihreys
			b, # Sinisyys
			]

	def send(self):
		bytes = bytearray(self.packet)
		self.socket.sendto(bytes, (self.ip, self.port))
		self.reset()

valot = Instanssi("faksu", "192.168.10.1", 9909)

#nollaus

for i in range(0,18):
	valot.set(18-i,0,0,0)
	valot.set(19+i,0,0,0)
	
def sekavari():
	return random.randint(1,255)

mixer.init(frequency=44100, size=-16, channels=2, buffer=4096)
mixer.music.load("murinat.ogg")
mixer.music.play()

# stackkäävä sininen
viimeinen = 18
while viimeinen != 0:
	for i in range(0, viimeinen):
		valot.set(i, 0, 255,0)
		valot.set(37-i, 255, 0,0)
		
		if i!=0 & i != viimeinen:
			valot.set(i-1, 0, 0,0)
		if i!=0 & i != viimeinen:
			valot.set(38-i, 0, 0,0)
			
		valot.send()
		time.sleep(0.08)
		
	viimeinen -= 1


#vasemmalta ja oikeelta takaisin keskelle väri ja nollaus
for i in range(0, 18):
	valot.set(i, sekavari(), sekavari(),sekavari())
	valot.set(37-i, sekavari(), sekavari(),sekavari())
		
	if i!=0:
		valot.set(i-1, 0, 0,0)
	if i!=0:
		valot.set(38-i, 0, 0,0)
			
	valot.send()
	time.sleep(0.1)

#3x kehä nopeutuen kolmella värillä
sleep = 0.1

for i in range(0,38):
	valot.set(i,255,0,0)
	
	valot.send()
	time.sleep(sleep)
	sleep -= 0.0008771929824561404

for i in range(0,38):
	valot.set(i,0,255,0)
	
	valot.send()
	time.sleep(sleep)
	sleep -= 0.0008771929824561404
	
for i in range(0,38):
	valot.set(i,0,0,255)
	
	valot.send()
	time.sleep(sleep)
	sleep -= 0.0008771929824561404
	
#sekavärille 3x nopeesti
for i in range(0,38):
	valot.set(38-i,sekavari(),sekavari(),sekavari())
	valot.send()
	time.sleep(0.05)

for i in range(0,38):
	valot.set(i,sekavari(),sekavari(),sekavari())
	if i!=0:
		valot.set(i, 0, 0,0)
	valot.send()
	time.sleep(0.04)
	
#uus stackki sekavarillä
loop = 18
while loop != 0:
	for i in range(0, loop):
		valot.set(i, sekavari(), sekavari(),sekavari())
		valot.set(37-i, sekavari(), sekavari(),sekavari())
		
		if i!=0:
			valot.set(i-1, 0, 0,0)
		if i!=0:
			valot.set(38-i, 0, 0,0)
			
		valot.send()
		time.sleep(0.003)
		
	loop -= 1

# Välkkeet tähän
for i in range(0,10000):
	time.sleep(0.1)

mixer.quit()
	
#kaikilla valoilla läpi kaikki värit
for i in range(0,255):
	for j in range(0,38):
		valot.set(j,i,0,0)
		valot.send()
	for j in range(0,38):
		valot.set(j,0,i,0)
		valot.send()
	for j in range(0,38):
		valot.set(j,0,0,i)
		valot.send()
	for j in range(0,38):
		valot.set(j,i,i,i)
		valot.send()
